//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FrameSnoop"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TMainForm::initializeControl()
{
  adapter.onCapture = adapter_OnCapture;
  edFileName->Text = ExtractFilePath(Application->ExeName) +
    FormatDateTime("YYYY.MM.DD HH NN SS", Now()) + ".cap";
}

void TMainForm::finalizeControl()
{
}

void TMainForm::loadControl()
{
  // WindowPos
  if (!global->loadWindowPos(Handle, "MainForm"))
  {
    Left = 0;
    Top = 0;
  }

  // Snoop
  VDXML* xml = global->xmlFile.root->gotoChild("Snoop");
  adapter.load(xml);
  SnoopFrame1->loadControl(&adapter);
}

void TMainForm::saveControl()
{
  // WindowPos
  global->saveWindowPos(Handle, "MainForm");

  // Snoop
  VDXML* xml = global->xmlFile.root->gotoChild("Snoop");
  SnoopFrame1->saveControl(&adapter);
  adapter.save(xml);
}

void TMainForm::setControl()
{
  bool active = adapter.active();

  btnOpen->Enabled = !active;
  btnClose->Enabled = active;
}

void TMainForm::adapter_OnCapture(
  SnoopCapturer* capturer,
  PKT_HDR*       pktHdr,
  char*          pktData)
{
  LOG_INFO("test");
  MainForm->dump.write(pktHdr, pktData);
  TStatusPanel* panel = MainForm->StatusBar1->Panels->Items[0];
  panel->Text = IntToStr(StrToInt(panel->Text) + 1);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  finalizeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnOpenClick(TObject *Sender)
{
  if (edFileName->Text == "")
  {
    MessageBox(0, "FileName must by specified", "Error", MB_ICONERROR);
    goto _error;
  }

  SnoopFrame1->saveControl(&adapter);
  if (!adapter.open())
  {
    string msg = "Error in open adapter ";
    msg += adapter.error.msg;
    MessageBox(0, msg.c_str(), "Error", MB_ICONERROR);
    goto _error;
  }

  if (!dump.open(edFileName->Text.c_str()))
  {
    string msg = "Error in open dump ";
    msg += dump.error();
    MessageBox(0, msg.c_str(), "Error", MB_ICONERROR);
    goto _error;
  }

  StatusBar1->Panels->Items[0]->Text = "0";
  setControl();
  return;

_error:
  btnClose->Click();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnCloseClick(TObject *Sender)
{
  adapter.close();
  dump.close();
  setControl();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtFileNameClick(TObject *Sender)
{
  if (SaveDialog1-> Execute())
    edFileName->Text = SaveDialog1->FileName;
}
//---------------------------------------------------------------------------

