//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
#include "SnoopAdapter.h"
#include "SnoopDump.h"
#include "FrameSnoop.h"
#include "Global.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TSnoopFrame *SnoopFrame1;
  TPanel *pnlTop;
  TButton *btnOpen;
  TButton *btnClose;
  TEdit *edFileName;
  TSaveDialog *SaveDialog1;
  TSpeedButton *sbtFileName;
  TStatusBar *StatusBar1;
  TBevel *Bevel1;
  TLabel *lblFileName;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall btnOpenClick(TObject *Sender);
  void __fastcall btnCloseClick(TObject *Sender);
  void __fastcall sbtFileNameClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
public:
  void initializeControl();
  void finalizeControl();
  void loadControl();
  void saveControl();
  void setControl();
public:
  SnoopAdapter adapter;
  SnoopDump dump;
  static void adapter_OnCapture(
    SnoopCapturer* capturer,
    PKT_HDR*       pktHdr,
    char*          pktData);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
